"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createNormalFragment = exports.createConnectionFragment = void 0;
var utilities_1 = require("../utilities");
exports.createConnectionFragment = function (typeName, allTypes, fragment) {
    var foundType = allTypes.find(function (f) { return f.name === typeName; });
    if (foundType) {
        var outputFragment_1 = '';
        var createLines_1 = function (field) {
            var _a;
            outputFragment_1 += field.name + " ";
            var _b = utilities_1.evaluateType(field), typeName = _b.typeName, isScalar = _b.isScalar;
            if (!isScalar) {
                if (field.name === 'node') {
                    outputFragment_1 += "{" + fragment + "} ";
                }
                else {
                    outputFragment_1 += "{ ";
                    var type = allTypes.find(function (f) { return f.name === typeName; });
                    (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach(createLines_1);
                    outputFragment_1 += "} ";
                }
            }
        };
        foundType.fields.map(createLines_1);
        return outputFragment_1;
    }
    return null;
};
exports.createNormalFragment = function (type, allTypes, connection) {
    var foundType = allTypes.find(function (f) { return f.name === type.name; });
    if (foundType) {
        var outputFragment_2 = '';
        var THRESHOLD_1 = connection ? 4 : 2;
        var createFragmentWithDeps_1 = function (field, level) {
            var _a, _b;
            var _c = utilities_1.evaluateType(field), typeName = _c.typeName, isScalar = _c.isScalar, isEnum = _c.isEnum, isEdge = _c.isEdge;
            if (!isScalar && !isEnum) {
                var type_1 = allTypes.find(function (f) { return f.name === typeName; });
                if (level < THRESHOLD_1) {
                    outputFragment_2 += field.name + " {";
                    (_a = type_1 === null || type_1 === void 0 ? void 0 : type_1.fields) === null || _a === void 0 ? void 0 : _a.forEach(function (m) { return createFragmentWithDeps_1(m, level + 1); });
                    outputFragment_2 += "} ";
                }
                else if ((type_1 === null || type_1 === void 0 ? void 0 : type_1.fields) && type_1.fields.length < 7) {
                    outputFragment_2 += field.name + " {";
                    (_b = type_1 === null || type_1 === void 0 ? void 0 : type_1.fields) === null || _b === void 0 ? void 0 : _b.forEach(function (m) { return createFragmentNoDeps_1(m, level + 1); });
                    outputFragment_2 += "} ";
                }
            }
            else {
                outputFragment_2 += field.name + " ";
            }
        };
        var createFragmentNoDeps_1 = function (field, level) {
            var _a = utilities_1.evaluateType(field), isScalar = _a.isScalar, isEnum = _a.isEnum;
            if (isScalar || isEnum) {
                outputFragment_2 += field.name + " ";
            }
        };
        foundType.fields.map(function (m) { return createFragmentWithDeps_1(m, 0); });
        return {
            fragment: outputFragment_2,
            foundName: foundType.name,
        };
    }
    return null;
};
